## goxel 0.10.6

=== Makefile ===
SHELL = bash
.ONESHELL:

all:
	scons -j 8

release:
	scons mode=release

profile:
	scons mode=profile

run:
	./goxel

clean:
	scons -c

# Make the doc using natualdocs.  On debian, we only have an old version
# of naturaldocs available, where it is not possible to exclude files by
# pattern.  I don't want to parse the C files (only the headers), so for
# the moment I use a tmp file to copy the sources and remove the C files.
# It's a bit ugly.
.PHONY: doc
doc:
	rm -rf /tmp/goxel_src
	cp -rf src /tmp/goxel_src
	find /tmp/goxel_src -name '*.c' | xargs rm
	mkdir -p doc ndconfig
	naturaldocs -i /tmp/goxel_src -o html doc -p ndconfig

# Targets to install/uninstall goxel and its data files on unix system.
PREFIX ?= /usr/local

.PHONY: install
install:
	install -Dm744 goxel $(DESTDIR)$(PREFIX)/bin/goxel
	for size in 16 24 32 48 64 128 256; do
	    install -Dm644 data/icons/icon$${size}.png \
	        $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/icons/hicolor/ \
	            $${size}x$${size}/apps/goxel.png)
	done
	install -Dm644 snap/gui/goxel.desktop \
	    $(DESTDIR)$(PREFIX)/share/applications/goxel.desktop
	install -Dm644 \
	    snap/gui/io.github.guillaumechereau.Goxel.appdata.xml \
	    $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/metainfo/ \
	        io.github.guillaumechereau.Goxel.appdata.xml)

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/goxel
	for size in 16 24 32 48 64 128 256; do \
	    rm -f $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/icons/hicolor/ \
	        $${size}x$${size}/apps/goxel.png)
	done
	rm -f $(DESTDIR)$(PREFIX)/share/applications/goxel.desktop
	rm -f $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/metainfo/ \
	         io.github.guillaumechereau.Goxel.appdata.xml)

=== SConstruct ===
# Goxel 3D voxels editor
#
# copyright (c) 2018 Guillaume Chereau <guillaume@noctua-software.com>
#
# Goxel is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# Goxel is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# goxel.  If not, see <http://www.gnu.org/licenses/>.

import glob
import os
import sys

vars = Variables('settings.py')
vars.AddVariables(
    EnumVariable('mode', 'Build mode', 'debug',
        allowed_values=('debug', 'release', 'profile')),
    BoolVariable('werror', 'Warnings as error', True),
    BoolVariable('sound', 'Enable sound', False),
    BoolVariable('yocto', 'Enable yocto renderer', True),
    PathVariable('config_file', 'Config file to use', 'src/config.h'),
)

target_os = str(Platform())

env = Environment(variables = vars, ENV = os.environ)
conf = env.Configure()

if os.environ.get('CC') == 'clang':
    env.Replace(CC='clang', CXX='clang++')

# Hack for gcc <= 5, since pragma diagnostic push doesn't seem to work.
if env['CCVERSION'] and int(env['CCVERSION'].split('.')[0]) <= 5:
    env.Append(CCFLAGS=['-Wno-unused-function'])

# Asan & Ubsan (need to come first).
if env['mode'] == 'debug' and target_os == 'posix':
    env.Append(CCFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
               LINKFLAGS=['-fsanitize=address', '-fsanitize=undefined'],
               LIBS=['asan', 'ubsan'])


# Global compilation flags.
# CCFLAGS   : C and C++
# CFLAGS    : only C
# CXXFLAGS  : only C++
env.Append(
    CFLAGS=['-std=gnu99', '-Wall',
            '-Wno-unknow-pragma', '-Wno-unknown-warning-option'],
    CXXFLAGS=['-std=gnu++17', '-Wall', '-Wno-narrowing']
)

if env['werror']:
    env.Append(CCFLAGS='-Werror')


if env['mode'] == 'debug':
    env.Append(CCFLAGS=['-O0'])
else:
    env.Append(CCFLAGS='-O3', CPPDEFINES='NDEBUG')
    if env['CC'] == 'gcc': env.Append(CCFLAGS='-Ofast')

if env['mode'] in ('profile', 'debug'):
    env.Append(CCFLAGS='-g')

env.Append(CPPPATH=['src'])
env.Append(CCFLAGS=['-include', '$config_file'])

# Get all the c and c++ files in src, recursively.
sources = []
for root, dirnames, filenames in os.walk('src'):
    for filename in filenames:
        if filename.endswith('.c') or filename.endswith('.cpp'):
            sources.append(os.path.join(root, filename))

# Check for libpng.
if conf.CheckLibWithHeader('libpng', 'png.h', 'c'):
    env.Append(CPPDEFINES='HAVE_LIBPNG=1')

# Linux compilation support.
if target_os == 'posix':
    env.Append(LIBS=['GL', 'm'])
    # Note: add '--static' to link with all the libs needed by glfw3.
    env.ParseConfig('pkg-config --libs glfw3')
    env.ParseConfig('pkg-config --cflags --libs gtk+-3.0')

# Windows compilation support.
if target_os == 'msys':
    env.Append(CXXFLAGS=['-Wno-attributes', '-Wno-unused-variable',
                         '-Wno-unused-function'])
    env.Append(LIBS=['glfw3', 'opengl32', 'Imm32', 'gdi32', 'Comdlg32',
                     'z', 'tre', 'intl', 'iconv'],
               LINKFLAGS='--static')
    sources += glob.glob('ext_src/glew/glew.c')
    env.Append(CPPPATH=['ext_src/glew'])
    env.Append(CPPDEFINES=['GLEW_STATIC', 'FREE_WINDOWS'])

# OSX Compilation support.
if target_os == 'darwin':
    sources += glob.glob('src/*.m')
    env.Append(FRAMEWORKS=['OpenGL', 'Cocoa'])
    env.Append(LIBS=['m', 'glfw3', 'objc'])

# Add external libs.
env.Append(CPPPATH=['ext_src/uthash'])
env.Append(CPPPATH=['ext_src/stb'])
env.Append(CPPPATH=['ext_src/noc'])
env.Append(CPPPATH=['ext_src/xxhash'])

if env['sound']:
    env.Append(LIBS='openal')
    env.Append(CPPDEFINES='SOUND=1')

if not env['yocto']:
    env.Append(CPPDEFINES='YOCTO=0')

# Append external environment flags
env.Append(
    CFLAGS=os.environ.get("CFLAGS", "").split(),
    CXXFLAGS=os.environ.get("CXXFLAGS", "").split(),
    LINKFLAGS=os.environ.get("LDFLAGS", "").split()
)

env.Program(target='goxel', source=sources)

=== debian/changelog ===
goxel (0.10.6-3) unstable; urgency=high

  * Remove architectures failing to build

 -- Federico Ceratto <federico@debian.org>  Sun, 31 Jan 2021 21:51:33 +0000

goxel (0.10.6-2) unstable; urgency=medium

  * Link to libatomic (Closes: #964403)
  * Use packaged libstb (Closes: #949552)
  * Drop inih dep (Closes: #978021)

 -- Federico Ceratto <federico@debian.org>  Fri, 25 Dec 2020 19:30:10 +0000

goxel (0.10.6-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix typo (Closes: #914749)

 -- Federico Ceratto <federico@debian.org>  Sat, 20 Jun 2020 21:01:53 +0100

=== debian/control ===
Source: goxel
Section: graphics
Priority: optional
Maintainer: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper-compat (= 13),
 clang,
 help2man,
 libatomic1,
 libglfw3-dev,
 libgtk-3-dev,
 libstb-dev,
 scons,
 uthash-dev
Standards-Version: 4.5.1
Homepage: https://github.com/guillaumechereau/goxel
Vcs-Git: https://salsa.debian.org/debian/goxel.git
Vcs-Browser: https://salsa.debian.org/debian/goxel
Rules-Requires-Root: no

Package: goxel
Architecture: amd64 arm64 armel armhf i386 m68k mips powerpc ppc64 ppc64el sh4 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 3D voxel editor
 Goxel is a 3D program that lets you create voxel volumes.
 It supports 24 bits RGB colors, unlimited scene size and undo buffers.
 Layers, procedural generation and Marching Cube rendering.
 Exports to obj, ply, magica voxel, png, qubicle, povray, and more

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

# link to libatomic on armel and mipsel
ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png
	rm -rf .sconsign.dblite
	if [ -d .ext_src ]; then rm ext_src -rf; mv .ext_src ext_src; fi

override_dh_auto_build:
	# extract only the required dependencies
	mv ext_src .ext_src
	mkdir ext_src
	cp -a .ext_src/imgui ext_src
	cp -a .ext_src/inih ext_src
	cp -a .ext_src/json ext_src
	cp -a .ext_src/lua ext_src
	cp -a .ext_src/noc ext_src
	cp -a .ext_src/xxhash ext_src
	cp -a .ext_src/yocto ext_src
	cp -a /usr/include/stb ext_src
	scons cycles=0 debug=0 clang=1 --jobs=$(NUMJOBS) --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png
	rm ext_src -rf
	mv .ext_src ext_src

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="$(DEB_VERSION)" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1

override_dh_usrlocal:
	true

override_dh_auto_install:
	PREFIX=/usr dh_auto_install

## goxel 0.10.8

=== SConstruct ===
--- 
+++ 
@@ -22,7 +22,7 @@
 vars = Variables('settings.py')
 vars.AddVariables(
     EnumVariable('mode', 'Build mode', 'debug',
-        allowed_values=('debug', 'release', 'profile')),
+        allowed_values=('debug', 'release', 'profile', 'analyze')),
     BoolVariable('werror', 'Warnings as error', True),
     BoolVariable('sound', 'Enable sound', False),
     BoolVariable('yocto', 'Enable yocto renderer', True),
@@ -33,6 +33,14 @@
 
 env = Environment(variables = vars, ENV = os.environ)
 conf = env.Configure()
+
+if env['mode'] == 'analyze':
+    # Make sure clang static analyzer has a chance to override de compiler
+    # and set CCC settings
+    env["CC"] = os.getenv("CC") or env["CC"]
+    env["CXX"] = os.getenv("CXX") or env["CXX"]
+    env["ENV"].update(x for x in os.environ.items() if x[0].startswith("CCC_"))
+
 
 if os.environ.get('CC') == 'clang':
     env.Replace(CC='clang', CXX='clang++')
@@ -61,12 +69,11 @@
 if env['werror']:
     env.Append(CCFLAGS='-Werror')
 
+if env['mode'] not in ['debug', 'analyze']:
+    env.Append(CPPDEFINES='NDEBUG', CCFLAGS='-Ofast')
 
 if env['mode'] == 'debug':
     env.Append(CCFLAGS=['-O0'])
-else:
-    env.Append(CCFLAGS='-O3', CPPDEFINES='NDEBUG')
-    if env['CC'] == 'gcc': env.Append(CCFLAGS='-Ofast')
 
 if env['mode'] in ('profile', 'debug'):
     env.Append(CCFLAGS='-g')
@@ -107,7 +114,7 @@
 if target_os == 'darwin':
     sources += glob.glob('src/*.m')
     env.Append(FRAMEWORKS=['OpenGL', 'Cocoa'])
-    env.Append(LIBS=['m', 'glfw3', 'objc'])
+    env.Append(LIBS=['m', 'glfw', 'objc'])
 
 # Add external libs.
 env.Append(CPPPATH=['ext_src/uthash'])
@@ -129,4 +136,4 @@
     LINKFLAGS=os.environ.get("LDFLAGS", "").split()
 )
 
-env.Program(target='goxel', source=sources)
+env.Program(target='goxel', source=sorted(sources))

=== debian/changelog ===
goxel (0.10.8-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sat, 29 Jan 2022 15:25:15 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libstb-dev,
  scons,
  uthash-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/guillaumechereau/goxel
 Vcs-Git: https://salsa.debian.org/debian/goxel.git
 Vcs-Browser: https://salsa.debian.org/debian/goxel

## goxel 0.11.0

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,9 @@
 
 clean:
 	scons -c
+
+analyze:
+	scan-build scons mode=analyze
 
 # Make the doc using natualdocs.  On debian, we only have an old version
 # of naturaldocs available, where it is not possible to exclude files by
@@ -34,7 +37,7 @@
 
 .PHONY: install
 install:
-	install -Dm744 goxel $(DESTDIR)$(PREFIX)/bin/goxel
+	install -Dm755 goxel $(DESTDIR)$(PREFIX)/bin/goxel
 	for size in 16 24 32 48 64 128 256; do
 	    install -Dm644 data/icons/icon$${size}.png \
 	        $$(printf '%s%s' $(DESTDIR)$(PREFIX)/share/icons/hicolor/ \

=== SConstruct ===
--- 
+++ 
@@ -115,6 +115,9 @@
     sources += glob.glob('src/*.m')
     env.Append(FRAMEWORKS=['OpenGL', 'Cocoa'])
     env.Append(LIBS=['m', 'glfw', 'objc'])
+    # Fix warning in noc_file_dialog (the code should be fixed instead).
+    env.Append(CCFLAGS=['-Wno-deprecated-declarations'])
+    env['sound'] = False
 
 # Add external libs.
 env.Append(CPPPATH=['ext_src/uthash'])

=== debian/changelog ===
goxel (0.11.0-1.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:50:27 +1100

goxel (0.11.0-1.1build2) noble; urgency=medium

  * No-change rebuild against libgtk-3-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 06:10:59 +0000

goxel (0.11.0-1.1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:47:07 +0000

goxel (0.11.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build without sanitizers. (Closes: #1031741)
  * Build on all architectures again.

 -- Adrian Bunk <bunk@debian.org>  Mon, 20 Mar 2023 09:46:36 +0200

goxel (0.11.0-1) unstable; urgency=medium

  * New upstream release (Closes: #984155)

 -- Federico Ceratto <federico@debian.org>  Wed, 11 Jan 2023 21:54:53 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: goxel
 Section: graphics
 Priority: optional
-Maintainer: Federico Ceratto <federico@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Federico Ceratto <federico@debian.org>
 Build-Depends: debhelper-compat (= 13),
  clang,
  help2man,
@@ -18,7 +19,7 @@
 Rules-Requires-Root: no
 
 Package: goxel
-Architecture: amd64 arm64 armel armhf i386 m68k mips powerpc ppc64 ppc64el sh4 x32
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: 3D voxel editor
  Goxel is a 3D program that lets you create voxel volumes.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

# link to libatomic on armel and mipsel
ifneq (,$(filter $(DEB_HOST_ARCH), armel mipsel))
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

include /usr/share/dpkg/default.mk  # provides DEB_VERSION

%:
	dh $@

override_dh_auto_clean:
	scons -c
	rm -rf .sconf_temp config.log debian/goxel.1 goxel.xpm goxel.png
	rm -rf .sconsign.dblite

override_dh_auto_build:
	scons cycles=0 mode=release werror=0 clang=1 --jobs=$(NUMJOBS) --no-cache
	cp -a ./osx/goxel/goxel/Assets.xcassets/AppIcon.appiconset/64.png ./goxel.png

override_dh_installman:
	help2man -N --no-discard-stderr \
		--no-info --version-string="$(DEB_VERSION)" \
		-n "3D voxel editor" ./goxel > debian/goxel.1
	dh_installman ./debian/goxel.1

override_dh_usrlocal:
	true

override_dh_auto_install:
	PREFIX=/usr dh_auto_install

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/goxel-$1\.tar\.gz/ https://github.com/guillaumechereau/goxel/tags .*/v?(\d\S*)\.tar\.gz
